//--------------------------------------------------------------------
//   .mq4 
//--------------------------------------------------------------------
#property copyright "Copyright  Equilibrium 2012"
#property link      "Equilibrium007@mail.ru"
//--------------------------------------------------------------------
                                   //    15
extern double StopLoss   =20;      // SL   
extern double TakeProfit =150;      //    
extern double Lots       =1;     //   . 
extern double Prots      =0.07;    //   
extern int Kperiod       =5;        //     %
extern int Dperiod       =3;        //      %D
extern int Slowing       =3;        //  
extern int Price_field   =0;        //     

bool Work=true;                    //   .
string Symb;                       //  . 
//--------------------------------------------------------------------
int start()
  {
   static int Ticket_B;             //   Buy
   static int Ticket_S;             //   Sell
   int
   M_0,                             //  MAIN  0 
   M_1,                             //  MAIN  1 
   S_0,                             //  SIGNAL  0 
   S_1,                             //  SIGNAL  1 
   Total;                           //     
   double                            
   Lot,                             // .   .
   Lts,                             // .   .
   Min_Lot,                         //   
   Step,                            //    
   Free,                            //   
   One_Lot,                         //   
   Price,                           //   
   SL,                              // SL   
   TP;                              // TP  
   bool
   Ans  =false,                     //    
   Cls_B=false,                           //     Buy
   Cls_S=false,                           //     Sell
   Opn_B=false,                           //     Buy
   Opn_S=false,                           //     Sell
   Retention_B=true,                     //    Buy
   Retention_S=true;                     //    Sell
   Symb=Symbol();
   
//-------------------------------------------------------------------
   // .
   if(Bars < Kperiod)                           //  
     {
      Alert("   .   .");
      return;                                   //   start()
     }
   if(Work==false)                              //  
     {
      Alert(" .   .");
      return;                                   //   start()
     }
//--------------------------------------------------------------------
                                   
   Total=OrdersTotal();                         //  
   
   
//------------------------------------------------------------------
     //  
   RefreshRates();                              //  
   Min_Lot=MarketInfo(Symb,MODE_MINLOT);        // . .  
   Free   =AccountFreeMargin();                 //  
   One_Lot=MarketInfo(Symb,MODE_MARGINREQUIRED);//  1 
   Step   =MarketInfo(Symb,MODE_LOTSTEP);       //   

   if (Lots > 0)                                //   , 
      Lts =Lots;                                //     
   else                                         // %  
      Lts=MathFloor(Free*Prots/One_Lot/Step)*Step;//  

   if(Lts < Min_Lot) Lts=Min_Lot;               //   
   if (Lts*One_Lot > Free)                      //   .
     {
      Alert("     ", Lts," ");
      return;                                   //   start()
     }
//---------------------------------------------------------------------  
   //  .    ..
   
   M_0=iStochastic(NULL,0,Kperiod,Dperiod,Slowing,MODE_SMMA,Price_field,MODE_MAIN,  0);// 0 
   M_1=iStochastic(NULL,0,Kperiod,Dperiod,Slowing,MODE_SMMA,Price_field,MODE_MAIN,  1);// 1 
   S_0=iStochastic(NULL,0,Kperiod,Dperiod,Slowing,MODE_SMMA,Price_field,MODE_SIGNAL,0);// 0 
   S_1=iStochastic(NULL,0,Kperiod,Dperiod,Slowing,MODE_SMMA,Price_field,MODE_SIGNAL,1);// 1 

   //  
   
   if (M_1 < S_1 && M_0<=(S_0+1) && M_0>=(S_0-1))  //    
     {
      Opn_B=true;                                  //  . Buy
      Cls_S=true;                                  //  . Sell  
      Retention_S=false;                            
     } 
   if (M_1 > S_1 && M_0<=(S_0+1) && M_0>=(S_0-1))  //    
     { 
      Opn_S=true;                                  //  . Sell
      Cls_B=true;                                  //  . Buy
      Retention_B=false;                            
     }
   if (M_1 > S_1 && M_0 > S_0 && Total>0)          //   
     {
      Alert("  .");        //   
     }else  
     {
      Alert("   .");                //   
     }   
   if (M_1 < S_1 && M_0 < S_0 && Total>0)          //   
     {
      Alert("  .");        //   
     }else 
     {
      Alert("   .");                //   
     }               
    
//---------------------------------------------------------------------  
//  
   while(true)//   .
     {
      if (Opn_B==true)                          //   
        {                                       //  . Buy
         RefreshRates();                        //  
         SL=Bid - New_Stop(StopLoss)*Point;     //  SL .
         TP=Bid + New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Buy.  ..");
         Ticket_B=OrderSend(Symb,OP_BUY,Lts,Ask,2,SL,TP);// Buy
         if (Ticket_B > 0)                        //  :)
           {
            Alert ("  Buy ",Ticket_B);
            return;                             //   start()
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      if (Opn_S==true)                          //  
        {                                       //  . Sell
         RefreshRates();                        //  
         SL=Ask + New_Stop(StopLoss)*Point;     //  SL .
         TP=Ask - New_Stop(TakeProfit)*Point;   //  TP .
         Alert("  Sell.  ..");
         Ticket_S=OrderSend(Symb,OP_SELL,Lts,Bid,2,SL,TP);// Sel
         if (Ticket_S > 0)                        //  :)
           {
            Alert ("  Sell ",Ticket_S);
            return;                             //   start()
           }
         if (Fun_Error(GetLastError())==1)      //  
            continue;                           //  
         return;                                //   start()
        }
      break;                                    //   while
     } 
     
 //  
   while(Retention_B==false || Retention_S==false)//   .
     {
        if (Cls_B==true)                      //  
          {                                       //   
           Alert("  Buy ",Ticket_B,".  ..");
           RefreshRates();                        //  
           Ans=OrderClose(Ticket_B,Lot,Bid,2);      //  Buy
           if (Ans==true)                         //  :)
             {
              Alert ("  Buy ",Ticket_B);
              break;                              //    
             }
           if (Fun_Error(GetLastError())==1)      //  
              continue;                           //  
           }
          
        if (Cls_S==true)                      //  
          {                                       //    
           Alert("  Sell ",Ticket_S,".  ..");
           RefreshRates();                        //  
           Ans=OrderClose(Ticket_S,Lot,Ask,2);      //  Sell
           if (Ans==true)                         //  :)
             {
              Alert ("  Sell ",Ticket_S);
              break;                              //    
             }
           
           if (Fun_Error(GetLastError())==1)      //  
              continue;                           //  
          }
       }                                   //   while
//--------------------------------------------------------------------
   return;                                      //   start()
  }
//--------------------------------------------------------------------
int Fun_Error(int Error)                        // -  
  {
   switch(Error)
     {                                          //              
      case  4: Alert("  .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 135:Alert(" .   ..");
         RefreshRates();                        //  
         return(1);                             //   
      case 136:Alert(" .   ..");
         while(RefreshRates()==false)           //   
            Sleep(1);                           //   
         return(1);                             //   
      case 137:Alert(" .   ..");
         Sleep(3000);                           //  
         return(1);                             //   
      case 146:Alert("  .  ..");
         Sleep(500);                            //  
         return(1);                             //   
         //  
      case  2: Alert(" .");
         return(0);                             //   
      case  5: Alert("  .");
         Work=false;                            //   
         return(0);                             //   
      case 64: Alert(" .");
         Work=false;                            //   
         return(0);                             //   
      case 133:Alert(" .");
         return(0);                             //   
      case 134:Alert("    .");
         return(0);                             //   
      default: Alert("  ",Error); //     
         return(0);                             //   
     }
  }
//--------------------------------------------------------------------
int New_Stop(int Parametr)                      //  -.
  {
   int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);// . 
   if (Parametr<Min_Dist)                       //   .
     {
      Parametr=Min_Dist;                        //  .
      Alert("  -.");
     }
   return(Parametr);                            //  
  }
//--------------------------------------------------------------------